--- lib/dns/acl.c.old	2010-06-05 00:41:38.000000000 +0100
+++ lib/dns/acl.c	2010-06-05 00:48:43.000000000 +0100
@@ -35,6 +35,9 @@
 
 #ifdef SUPPORT_GEOIP
 static GeoIP *geoip = NULL;
+#ifdef GEOIP_V6
+static GeoIP *geoip6 = NULL;
+#endif
 #endif
 
 /*
@@ -396,25 +399,31 @@
 	case dns_aclelementtype_ipcountry:
 		/* Country match */
 		if (NULL == geoip) {
-			geoip = GeoIP_new(GEOIP_MEMORY_CACHE);
+                        if (GeoIP_db_avail(GEOIP_COUNTRY_EDITION))
+	        		geoip = GeoIP_open_type(GEOIP_COUNTRY_EDITION, GEOIP_MEMORY_CACHE);
 		}
-		if (NULL != geoip) {
-			const char *value = NULL;
+#ifdef GEOIP_V6
+		if (NULL == geoip6) {
+                        if (GeoIP_db_avail(GEOIP_COUNTRY_EDITION_V6))
+	        		geoip = GeoIP_open_type(GEOIP_COUNTRY_EDITION_V6, GEOIP_MEMORY_CACHE);
+		}
+#endif
 
-			if (reqaddr->family == AF_INET) {
-				value = GeoIP_country_code_by_addr(geoip,inet_ntoa(reqaddr->type.in));
+                const char *value = NULL;
+
+		if (reqaddr->family == AF_INET) {
+			value = GeoIP_country_code_by_addr(geoip,inet_ntoa(reqaddr->type.in));
 #ifdef GEOIP_V6
-			} else if (reqaddr->family == AF_INET6) {
-				value = GeoIP_country_name_by_ipnum_v6(geoip, (geoipv6_t)reqaddr->type.in6);
+		} else if (reqaddr->family == AF_INET6) {
+			value = GeoIP_country_name_by_ipnum_v6(geoip6, (geoipv6_t)reqaddr->type.in6);
 #endif
-			}
+		}
                 
-			if ((NULL != value) && (2 == strlen(value))) {
-				if ((e->country[0] == value[0]) && (e->country[1] == value[1])) {
-					return (ISC_TRUE);
-				}
+		if ((NULL != value) && (2 == strlen(value))) {
+			if ((e->country[0] == value[0]) && (e->country[1] == value[1])) {
+				return (ISC_TRUE);
 			}
-                }
+		}
 		return (ISC_FALSE);
 #endif
 
